;
; C[t[3DOtBbN
; f(C)
;
.include "3d.h"

W = 600
L = 600
H = 200

; C
main::
	; Cu
	call init_3d

	; J̈ʒuƌݒ肷
	ld IY, #camera_mat
	call clear_matxyz

	; ̂NA
	ld IX, #objs_cube
	call clear_objs
	ld IX, #objs_hex
	call clear_objs
	ld IX, #obj_you
	call clear_objs

	; ̂zu
	ld HL, #cube
	ld IX, #objs_cube
	ld B, #12
	call add_objs
	ld HL, #hex
	ld IX, #objs_hex
	ld B, #6
	call add_objs

	; @zu
	ld HL, #you
	ld IX, #obj_you
	call add_obj
	ld (#you_mat), IY

main_loop:
	; L[͂
	ld HL, #key
	ld (HL), #0
	;; L[͂𓾂
	;ld A, #0x08
	;out (#0x11), A
	;in A, (#0x10)
	;; Xy[X
	;cp #0x20
	;jr Z, input1_last
input1_last:

	; L[͂𓾂
	ld A, #0x60
	out (#0x11), A
	in A, (#0x10)
	push AF
	and #0x80
	call NZ, view_lower
	ld A, #0xc0
	out (#0x11), A
	pop AF
	; 
	ld B, #0x01
	cp #0x08
	jr Z, input2_last
	; 
	ld B, #0x08
	cp #0x10
	jr Z, input2_last
	; 
	ld B, #0x09
	cp #0x18
	jr Z, input2_last
	; E
	ld B, #0x02
	cp #0x20
	jr Z, input2_last
	; E
	ld B, #0x0a
	cp #0x30
	jr Z, input2_last
	; Ȃ
	ld B, #0
input2_last:
	ld A, B
	ld HL, #key
	or (HL)
	ld (HL), A

	; @̌ݒ肷
	ld IY, (#you_mat)
	ld A, (#you_yaw)
	call let_yaw

	; L[͂𓾂
	;ld A, #0xc0
	;out (#0x11), A
	in A, (#0x10)
	push AF
	and #0x80
	call NZ, view_upper
	xor A
	out (#0x11), A
	pop AF
	; 
	ld B, #0x04
	cp #0x10
	jr Z, input3_last
	; 
	ld B, #0x05
	cp #0x18
	jr Z, input3_last
	; E
	ld B, #0x06
	cp #0x30
	jr Z, input3_last
	; Ȃ
	ld B, #0
input3_last:
	ld A, B
	ld HL, #key
	or (HL)
	ld (HL), A

	; @̕ݒ肷
	ld HL, #you_yaw
	and #0x03
	inc (HL)
	cp #0x01
	jr Z, yaw_last
	dec (HL)
	dec (HL)
	cp #0x02
	jr Z, yaw_last
	inc (HL)
yaw_last:

	; @̑xݒ肷
	ld HL, (#you_speed)
	ld A, (#key)
	and #0x0c
	; Oi
	cp #0x04
	jr NZ, acc_skip
	inc HL
	inc HL
	push HL
	ld BC, #-12
	add HL, BC
	ld A, H
	rlca
	pop HL
	jr C, acc_last
	ld HL, (#you_speed)
	jr acc_last
acc_skip:
	; 
	cp #0x08
	jr NZ, acc_last
	dec HL
	dec HL
	push HL
	ld BC, #12
	add HL, BC
	ld A, H
	rlca
	pop HL
	jr NC, acc_last
	ld HL, (#you_speed)
acc_last:
	ld (#you_speed), HL

	; @
	ld DE, (#you_speed)
	ld A, E
	rlc A
	jr Z, deacc_last
	inc DE
	jr C, deacc_last
	dec DE
	dec DE
deacc_last:
	ld (#you_speed), DE
	ld IY, (#you_mat)
	push IY
	pop IX
	ld A, E
	call move_obj8

	; x𒲐
	call adjust
	jp NC, main_loop

	ld A, (#view)
	or A
	jr NZ, main_view_upper

main_view_lower:
	; J@̌Ɉړ
	ld IY, #camera_mat
	ld HL, (#you_mat)
	push HL
	call let_matxyz
	ld MAT_ZL(IY), #80
	pop IX
	ld IX, #camera_mat
	ld DE, #-0x0180
	call move_obj
	jr main_view_last

main_view_upper:
	; J@̌Ɉړ
	ld IY, #camera_mat
	ld HL, (#you_mat)
	call let_xyz
	ld MAT_ZL(IY), #128
	ld A, #-10
	call let_pitch
	ld A, (#you_yaw)
	call rotate_yaw
	ld IX, #camera_mat
	ld DE, #-0x0400
	call move_obj
main_view_last:

.if 0
	; nʂ\
	call draw_ground
.endif

	; ̂Ƃ̓蔻
	ld BC, #MAT_XL
	ld HL, (#you_mat)
	add HL, BC
	push HL
	ld BC, #70
	ld IX, #objs_cube
	ld IY, #hit_cube
	push HL
	push IX
	push IY
	call hittest_objs
	call C, friction_cube
	call C, crush
	pop IY
	pop IX
	pop HL
	call hitretest_objs
	call C, friction_cube
	call C, crush
	pop HL

	; ̂Ƃ̓蔻
	ld IX, #objs_hex
	ld IY, #hit_sphere
	push HL
	push IX
	push IY
	call hitretest_objs
	call C, friction_sphere
	call C, crush
	pop IY
	pop IX
	pop HL
	call hitretest_objs
	call C, friction_sphere
	call C, crush

	; s߂
	ld HL, #0
	ld (#objs_count), HL
	ld IX, #obj_you
	call camtrans_objs
	ld IX, #objs_cube
	call camtrans_objs
	ld IX, #objs_hex
	call camtrans_objs

	; \
	call cls
	call put_objs

	; BREAKL[ꂽ?
	in A, (#0x1f)
	rlca
	ret C
	jp main_loop

crush:
	ld B, #6
	ld DE, #0x0000
	ld HL, #msg_crush
	jp 0xbff1

msg_crush:
	.ascii /CRUSH!/

; ̂ǉ
add_objs:
	inc B
	dec B
	ret Z

add_objs_loop:
	push BC
	call add_obj
	push HL
	call rand
	call let_yaw
	pop HL
	call rand
	and #0xf0
	ld MAT_XL(IY), A
	call rand
	and #0x1f
	sub #0x0f
	ld MAT_XH(IY), A
	call rand
	and #0xf0
	ld MAT_YL(IY), A
	call rand
	and #0x1f
	sub #0x0f
	ld MAT_YH(IY), A
	ld MAT_ZL(IY), #0
	ld MAT_ZH(IY), #0
	pop BC
	djnz add_objs_loop
	ret

; 뎋_ɕς
view_lower:
	xor A
	ld (#view), A
	ret

; ΂ߏ㎋_ɕς
view_upper:
	ld A, #1
	ld (#view), A
	ret

msg_hit:
	.ascii /HIT!/

test1::
	call test2
	call test2
	ret

test2::
	ret

key:
	.db 0
you_mat:
	.dw 0
you_speed:
	.dw 0
you_yaw:
	.db 0
view:
	.db 0

;
; @f
;
you::
	.dw 200 ; a

	.db 4 ; _̐
	.dw 0, 100, 0 ; _0
	.dw -50, -90, 0 ; _1
	.dw 50, -90, 0 ; _2
	.dw 0, 0, 40 ; _3

	.db 4 ; ʂ̐
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX, 2 * SIZE_VERTEX ; 0̕\_
	.db 3 ; 0̕ӂ̐
	.dw you0, you1, you2 ; 0̕
	.dw 3 * SIZE_VERTEX, 2 * SIZE_VERTEX, 1 * SIZE_VERTEX ; 1̕\_
	.db 3 ; 1̕ӂ̐
	.dw you3, you1, you4 ; 1̕
	.dw 3 * SIZE_VERTEX, 0 * SIZE_VERTEX, 2 * SIZE_VERTEX ; 2̕\_
	.db 3 ; 2̕ӂ̐
	.dw you5, you2, you3 ; 2̕
	.dw 3 * SIZE_VERTEX, 1 * SIZE_VERTEX, 0 * SIZE_VERTEX ; 3̕\_
	.db 3 ; 3̕ӂ̐
	.dw you4, you0, you5 ; 3̕

	.db 6 ; ӂ̐
you0:
	.db 0
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX ; 0̗[̓_
you1:
	.db 0
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX ; 1̗[̓_
you2:
	.db 0
	.dw 0 * SIZE_VERTEX, 2 * SIZE_VERTEX ; 2̗[̓_
you3:
	.db 0
	.dw 2 * SIZE_VERTEX, 3 * SIZE_VERTEX ; 3̗[̓_
you4:
	.db 0
	.dw 1 * SIZE_VERTEX, 3 * SIZE_VERTEX ; 4̗[̓_
you5:
	.db 0
	.dw 0 * SIZE_VERTEX, 3 * SIZE_VERTEX ; 5̗[̓_

	.db 0 ; ̐

;
; ̃f
;
cube::
	.dw W * 14 / 10 / 2	; a
	.db 8	; _̐
	.dw W / 2, L / 2, H	; 0
	.dw -W / 2, L / 2, H	; 1
	.dw -W / 2, L / 2, 0	; 2
	.dw W / 2, L / 2, 0	; 3
	.dw W / 2, -L / 2, H	; 4
	.dw -W / 2, -L / 2, H	; 5
	.dw -W / 2, -L / 2, 0	; 6
	.dw W / 2, -L / 2, 0	; 7

	.db 6	; ʂ̐
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX, 2 * SIZE_VERTEX
	.db 4
	.dw cube0, cube1, cube2, cube3

	.dw 7 * SIZE_VERTEX, 6 * SIZE_VERTEX, 5 * SIZE_VERTEX
	.db 4
	.dw cube7, cube6, cube5, cube4

	.dw 0 * SIZE_VERTEX, 4 * SIZE_VERTEX, 5 * SIZE_VERTEX
	.db 4
	.dw cube8, cube4, cube9, cube0

	.dw 2 * SIZE_VERTEX, 6 * SIZE_VERTEX, 7 * SIZE_VERTEX
	.db 4
	.dw cube2, cube10, cube6, cube11

	.dw 7 * SIZE_VERTEX, 4 * SIZE_VERTEX, 0 * SIZE_VERTEX
	.db 4
	.dw cube8, cube7, cube11, cube3

	.dw 6 * SIZE_VERTEX, 2 * SIZE_VERTEX, 1 * SIZE_VERTEX
	.db 4
	.dw cube1, cube10, cube5, cube9

	.db 12	; ӂ̐
cube0:
	.db 0
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX	; 0
cube1:
	.db 0
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX	; 1
cube2:
	.db 0
	.dw 2 * SIZE_VERTEX, 3 * SIZE_VERTEX	; 2
cube3:
	.db 0
	.dw 3 * SIZE_VERTEX, 0 * SIZE_VERTEX	; 3
cube4:
	.db 0
	.dw 4 * SIZE_VERTEX, 5 * SIZE_VERTEX	; 4
cube5:
	.db 0
	.dw 5 * SIZE_VERTEX, 6 * SIZE_VERTEX	; 5
cube6:
	.db 0
	.dw 6 * SIZE_VERTEX, 7 * SIZE_VERTEX	; 6
cube7:
	.db 0
	.dw 7 * SIZE_VERTEX, 4 * SIZE_VERTEX	; 7
cube8:
	.db 0
	.dw 0 * SIZE_VERTEX, 4 * SIZE_VERTEX	; 8
cube9:
	.db 0
	.dw 1 * SIZE_VERTEX, 5 * SIZE_VERTEX	; 9
cube10:
	.db 0
	.dw 2 * SIZE_VERTEX, 6 * SIZE_VERTEX	; 10
cube11:
	.db 0
	.dw 3 * SIZE_VERTEX, 7 * SIZE_VERTEX	; 11

	.db 0	; ̐

;
; 蔻()
;
hit_cube:
	.db 1
	.dw (W / 2) * 141 / 100	; Oڋ̔a
	.dw -W / 2, W / 2	; XW͈
	.dw -L / 2, L / 2	; YW͈
	.dw 0, H / 2	; ZW͈

.if 0
;
; 4ʑ̃f
;
tri::
.if 0
	.dw H * 2	; a
	.db 4	; _̐
	.dw 0, L / 2, 0	; 0
	.dw (L * 9 / 10 / 2), -L / 2 / 2, 0	; 1
	.dw -(L * 9 / 10 / 2), -L / 2 / 2, 0	; 2
	.dw 0, 0, H * 2	; 3
.else
	.dw H * 2	; a
	.db 4	; _̐
	.dw 0, L / 10 * 6, 0	; 0
	.dw L / 2, -(L / 10 * 3), 0	; 1
	.dw -(L / 2), -(L / 10 * 3), 0	; 2
	.dw 0, 0, H * 2	; 3
.endif

	.db 4	; ʂ̐
	.dw 2 * SIZE_VERTEX, 1 * SIZE_VERTEX, 0 * SIZE_VERTEX
	.db 3
	.dw tri1, tri0, tri2
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX, 3 * SIZE_VERTEX
	.db 3
	.dw tri0, tri4, tri3
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX, 3 * SIZE_VERTEX
	.db 3
	.dw tri1, tri5, tri4
	.dw 0 * SIZE_VERTEX, 3 * SIZE_VERTEX, 2 * SIZE_VERTEX
	.db 3
	.dw tri3, tri5, tri2

	.db 6	; ӂ̐
tri0:
	.db 0
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX	; 0
tri1:
	.db 0
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX	; 1
tri2:
	.db 0
	.dw 2 * SIZE_VERTEX, 0 * SIZE_VERTEX	; 2
tri3:
	.db 0
	.dw 0 * SIZE_VERTEX, 3 * SIZE_VERTEX	; 3
tri4:
	.db 0
	.dw 1 * SIZE_VERTEX, 3 * SIZE_VERTEX	; 4
tri5:
	.db 0
	.dw 2 * SIZE_VERTEX, 3 * SIZE_VERTEX	; 5

	.db 0	; ̐

;
; 蔻(Op)
;
hit_tri:
	.db 2
	.dw L / 10 * 6	; a
	.dw -(L / 2), L / 2	; XW͈
	.dw -(L / 10 * 3), L / 10 * 6	; YW͈
	.dw 0, H * 2	; ZW͈
.endif

;
; Zpf
;
hex::
	.dw 400 ; a

	.db 7 ; _̐
	.dw 0, 300, 0 ; _0
	.dw 256, 150, 0 ; _1
	.dw 256, -150, 0 ; _2
	.dw 0, -300, 0 ; _3
	.dw -256, -150, 0 ; _4
	.dw -256, 150, 0 ; _5
	.dw 0, 0, 400 ; _6

	.db 6 ; ʂ̐
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 0̕\_
	.db 3 ; 0̕ӂ̐
	.dw hex0, hex1, hex2 ; 0̕
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 1̕\_
	.db 3 ; 1̕ӂ̐
	.dw hex3, hex4, hex1 ; 1̕
	.dw 2 * SIZE_VERTEX, 3 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 2̕\_
	.db 3 ; 2̕ӂ̐
	.dw hex5, hex6, hex4 ; 2̕
	.dw 3 * SIZE_VERTEX, 4 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 3̕\_
	.db 3 ; 3̕ӂ̐
	.dw hex7, hex8, hex6 ; 3̕
	.dw 4 * SIZE_VERTEX, 5 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 4̕\_
	.db 3 ; 4̕ӂ̐
	.dw hex9, hex10, hex8 ; 4̕
	.dw 5 * SIZE_VERTEX, 0 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 5̕\_
	.db 3 ; 5̕ӂ̐
	.dw hex11, hex2, hex10 ; 5̕

	.db 12 ; ӂ̐
hex0:
	.db 0
	.dw 0 * SIZE_VERTEX, 1 * SIZE_VERTEX ; 0̗[̓_
hex1:
	.db 0
	.dw 1 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 1̗[̓_
hex2:
	.db 0
	.dw 0 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 2̗[̓_
hex3:
	.db 0
	.dw 1 * SIZE_VERTEX, 2 * SIZE_VERTEX ; 3̗[̓_
hex4:
	.db 0
	.dw 2 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 4̗[̓_
hex5:
	.db 0
	.dw 2 * SIZE_VERTEX, 3 * SIZE_VERTEX ; 5̗[̓_
hex6:
	.db 0
	.dw 3 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 6̗[̓_
hex7:
	.db 0
	.dw 3 * SIZE_VERTEX, 4 * SIZE_VERTEX ; 7̗[̓_
hex8:
	.db 0
	.dw 4 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 8̗[̓_
hex9:
	.db 0
	.dw 4 * SIZE_VERTEX, 5 * SIZE_VERTEX ; 9̗[̓_
hex10:
	.db 0
	.dw 5 * SIZE_VERTEX, 6 * SIZE_VERTEX ; 10̗[̓_
hex11:
	.db 0
	.dw 0 * SIZE_VERTEX, 5 * SIZE_VERTEX ; 11̗[̓_

	.db 0 ; ̐

;
; 蔻()
;
hit_sphere:
	.db 0
	.dw 256	; ̔a

; eof
